<?
  # Program id   : Kpd2GMemberTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--sզ table Groupmember
  #
  #
  class Kpd2GMemberTable
  {
    var $MaxItem;
    var $groupno;
    var $organo;
    var $organoset;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2GMemberTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->groupno     = array();
      $this->organo      = array();
      $this->organoset   = array();
      $this->_error      = '';
      $this->Db          = &$db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2GMemberTable($groupno='')
    {
      $groupno           = trim($groupno);
      $this->MaxItem     = 0;
      $this->groupno     = array();
      $this->organo      = array();
      $this->organoset   = array();
      $query  = "SELECT * FROM groupmember ";
      if  (!empty($groupno))
      {
        $query .= "WHERE groupno = '$groupno' ";
      }
      $query .= " ORDER BY groupno, organo";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->groupno[$i]              = $data->groupno;
        $this->organo[$i]               = $data->organo;
        $this->organoset[$data->organo] = TRUE;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2GMemberTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $groupno = trim($this->groupno[$i]);
        $organo  = strtoupper(trim($this->organo[$i]));
        $query  = "INSERT INTO groupmember (";
        $query .= "groupno, organo)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$groupno', ";
        $query .= "'$organo' ";
        $query .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2GMemberTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $groupno = trim($this->groupno[$i]);
        $organo  = strtoupper(trim($this->organo[$i]));
        $query  = "DELETE FROM groupmember WHERE groupno = '$groupno'  ";
        if  (strlen($organo) > 0)
        {
          $query .= "AND organo = '$organo' ";
        }
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return(true);
    }
  }
?>