<?
  # Program id   : Kpd2GroupTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--s table Group
  #
  #
  class Kpd2GroupTable
  {
    var $MaxItem;
    var $no;
    var $name;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2GroupTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->no          = array();
      $this->name        = array();
      $this->_error      = '';
      $this->Db          = $db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2GroupTable($no='')
    {
      $no                = trim($no);
      $this->MaxItem     = 0;
      $this->no          = array();
      $this->name        = array();
      $query  = "SELECT * FROM grouptable ";
      if  (!empty($no))
      {
        $query .= "WHERE no = '$no' ";
      }
      else
      {
        $query .= " ORDER BY no";
      }
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->no[$i]    = $data->no;
        $this->name[$i]  = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2GroupTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $no     = trim($this->no[$i]);
        $name   = addslashes(trim($this->name[$i]));
        $query  = "INSERT INTO grouptable (";
        $query .= "name, no)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$name', ";
        $query .= "'$no' ";
        $query .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2GroupTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $no     = trim($this->no[$i]);
        $name   = addslashes(trim($this->name[$i]));
        $query  = "UPDATE grouptable SET ";
        $query .= "name = '$name' ";
        $query .= "WHERE ";
        $query .= "no = '$no' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2GroupTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $no     = trim($this->no[$i]);
        $query  = "DELETE FROM grouptable ";
        if  (strlen($no) > 0)
        {
          $query .= "WHERE no = '$no' ";
        }
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return(true);
    }
  }
?>