<?
  # Program id   : Kpd2LogsTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--sO
  #
  #
  #
  # logs op type
  #
  if (!defined("OP_MGR"))
  {
    define("OP_MGR", "0", TRUE);
    define("OP_ORG", "1", TRUE);
    define("OP_COD", "2", TRUE);
    define("OP_USR", "3", TRUE);
    define("OP_SIG", "4", TRUE);
    define("OP_SUD", "5", TRUE);
    define("OP_SUR", "6", TRUE);
    define("OP_OTH", "z", TRUE);
    $op_type_desc = array(
                          OP_MGR => '޲zv',  
                          OP_ORG => 'NX',  
                          OP_COD => 'NX޲z',  
                          OP_USR => 'ϥΪv',  
                          OP_SIG => 'nJnX',  
                          OP_SUD => 'ݨ]p',  
                          OP_SUR => 'ݨn',  
                          OP_OTH => 'L'  
                         );
  }
  #
  class Kpd2LogsTable
  {
    var $MaxItem;
    var $AccessTime;
    var $Remote_IP;
    var $Operator;
    var $ProgramID;
    var $Op_type;
    var $Details;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2LogsTable(&$db)
    {
      $this->MaxItem    = 0;
      $this->AccessTime = array();
      $this->Remote_IP  = array();
      $this->Operator   = array();
      $this->ProgramID  = array();
      $this->Op_type    = array();
      $this->Details    = array();
      $this->_error      = '';
      $this->Db          = $db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2LogsTable($begtime='', $endtime='')
    {
      $this->MaxItem    = 0;
      $this->AccessTime = array();
      $this->Remote_IP  = array();
      $this->Operator   = array();
      $this->ProgramID  = array();
      $this->Op_type    = array();
      $this->Details    = array();
      $query  = "SELECT * FROM logs ";
      if  ($begtime != '' && $endtime != '')
      {
        $query .= " where accesstime >= '$begtime' AND accesstime <= '$endtime'";
      }
      $query .= " ORDER BY accesstime ";
      # echo "$query<br>\n"; 
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->AccessTime[$i] = $data->accesstime;
        $this->Remote_IP[$i]  = $data->remote_ip;
        $this->Operator[$i]   = $data->operator;
        $this->ProgramID[$i]  = $data->programid;
        $this->Op_type[$i]    = $data->op_type;
        $this->Details[$i]    = $data->details;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2LogsTable()
    {
      global $_SERVER;
      if  (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
      {
        $remote_addr=sprintf("%s/%s(%s/%s)", 
                             $this->GetHostName($_SERVER['HTTP_X_FORWARDED_FOR']), 
                             $this->GetHostName($_SERVER['REMOTE_ADDR']), 
                             $_SERVER['HTTP_X_FORWARDED_FOR'], 
                             $_SERVER['REMOTE_ADDR']
                            );
      }
      else
      {
        $remote_addr=sprintf("%s(%s)", 
                             $this->GetHostName($_SERVER['REMOTE_ADDR']), 
                             $_SERVER['REMOTE_ADDR']
                            );
      }
      $remote_addr = AddSlashes($remote_addr);
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $operator  = AddSlashes(trim($this->Operator[$i]));
        $programid = AddSlashes(trim($this->ProgramID[$i]));
        $op_type   = $this->Op_type[$i];
        $details   = AddSlashes(trim($this->Details[$i]));
        $query  = "INSERT INTO logs(remote_ip, operator, programid, op_type, details)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$remote_addr', ";  
        $query .= "'$operator',";  
        $query .= "'$programid',";  
        $query .= "'$op_type',";  
        $query .= "'$details' ";  
        $query .= ")";
        #echo "$query<br>\n"; 
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          /***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          exit;
          ***/
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    //
    //
    function GetHostName($ip)
    {
      $ret='';
      $tmp = explode(",", $ip);
      return(gethostbyaddr($tmp[0]));
    }
    //
    // WriteAccessLog
    //
    function WriteAccessLog($operator, $programid, $op_type, $details)
    {
      $this->MaxItem      = 1;     
      $this->Operator[0]  = $operator;     
      $this->ProgramID[0] = $programid;     
      $this->Op_type[0]   = $op_type;     
      $this->Details[0]   = $details;
      return($this->InsertKpd2LogsTable());
    }
  }    
?>