<?
  # Program id   : Kpd2ManagerTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--޲z̥NX table
  #
  #
  class Kpd2ManagerTable
  {
    var $MaxItem;
    var $email;
    var $auth_code;
    var $remark;
    var $regdate;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2ManagerTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->email       = array();
      $this->auth_code   = array();
      $this->remark      = array();
      $this->regdate     = array();
      $this->_error      = '';
      $this->Db          = $db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2ManagerTable($email='')
    {
      $email = AddSlashes(trim($email));
      $query  = "SELECT * FROM manager ";
      if  (!empty($email))
      {
        $query .= "WHERE email = '$email' ORDER BY email ";
      }
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->email[$i]     = $data->email;
        $this->auth_code[$i] = $data->auth_code;
        $this->remark[$i]    = $data->remark;
        $this->regdate[$i]   = $data->regdate;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2ManagerTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email  = addslashes(trim($this->email[$i]));
        $remark = addslashes(trim($this->remark[$i]));
        $query  = "INSERT INTO manager (";
        $query .= "email, remark)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$email',  ";
        $query .= "'$remark'";
        $query .= ")";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2ManagerTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email  = addslashes(trim($this->email[$i]));
        $remark = addslashes(trim($this->remark[$i]));
        $query  = "UPDATE manager SET ";
        $query .= "remark   = '$remark', ";
        $query .= "regdate  = now() ";
        $query .= "WHERE ";
        $query .= "email = '$email' ";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        # echo "$query<br>\n" . $cmdTuples;
        # exit;
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2ManagerTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email = addslashes(trim($this->email[$i]));
        $query  = "DELETE FROM manager ";
        $query .= "WHERE ";
        $query .= "email = '$email' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return(true);
    }
  }
?>