<?
  # Program id   : Kpd2OrgaTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt-- table Orga
  #
  #
  class Kpd2OrgaTable
  {
    var $MaxItem;
    var $no;
    var $noset;
    var $name;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2OrgaTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->no          = array();
      $this->name        = array();
      $this->_error      = '';
      $this->Db          = $db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2OrgaTable($no='')
    {
      $no                = strtoupper(trim($no));
      $this->MaxItem     = 0;
      $this->no          = array();
      $this->name        = array();
      $query  = "SELECT * FROM orga ";
      if  (!empty($no))
      {
        $query .= "WHERE no = '$no' ";
      }
      else
      {
        $query .= " ORDER BY no";
      }
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->no[$i]           = $data->no;
        $this->noset[$data->no] = TRUE;
        $this->name[$i]         = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // SELECT  Index By no
    //
    function SelectKpd2OrgaTableIndexByNo($no='')
    {
      $no                = strtoupper(trim($no));
      $this->MaxItem     = 0;
      $this->no          = array();
      $this->name        = array();
      $query  = "SELECT * FROM orga ";
      if  (!empty($no))
      {
        $query .= "WHERE no = '$no' ";
      }
      else
      {
        $query .= " ORDER BY no";
      }
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->no[$i]           = $data->no;
        $this->noset[$data->no] = TRUE;
        $this->name[$data->no]  = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }

    //
    // SELECT  Index By pri
    //
    function SelectKpd2OrgaTableIndexByPri($no='')
    {
      $no                = strtoupper(trim($no));
      $this->MaxItem     = 0;
      $this->no          = array();
      $this->name        = array();
      $query  = "SELECT * FROM orga ORDER BY pri";

      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->no[$i]           = $data->no;
        $this->noset[$data->no] = TRUE;
        $this->name[$i]  = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }


    //
    // SELECT By Partial name
    //
    function SelectOrgaTableByName($name, $except='', $toplevel=false)
    {
      $this->MaxItem   = 0;
      $this->no        = array();
      $this->name      = array();
      $name        = AddSlashes(trim($name));
      $query  = "SELECT * FROM Orga";
      if  (!empty($name))
      {
        $query .= " where name LIKE '%$name%'";
      }
      if  (!empty($except))
      {
        if  (empty($name))
        {
          $query .= ' WHERE ';
        }
        else
        {
          $query .= ' AND ';
        }
        $query .= " name not LIKE '%$except%'";
      }
      if  ($toplevel)
      {
        if  (empty($name) && empty($except))
        {
          $query .= ' WHERE ';
        }
        else
        {
          $query .= ' AND ';
        }
        $query .= " substring(no, 6,  4) = '0000' ";
      }
      $query .= " ORDER BY no";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }

      // echo "$query<br>\n";
      /*****
      echo "<PRE>\n";
      print_r($rst);
      echo "</PRE>\n";
      exit;
      *****/
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->no[$i]           = $data->no;
        $this->noset[$data->no] = TRUE;
        $this->name[$i]         = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }

    //
    // SELECT  index By Partial name 
    //
    function SelectOrgaTableIndexByName($name, $except='', $toplevel=false)
    {
      $this->MaxItem   = 0;
      $this->no        = array();
      $this->name      = array();
      $name        = AddSlashes(trim($name));
      $query  = "SELECT * FROM Orga";
      if  (!empty($name))
      {
        $query .= " where name LIKE '%$name%'";
      }
      if  (!empty($except))
      {
        if  (empty($name))
        {
          $query .= ' WHERE ';
        }
        else
        {
          $query .= ' AND ';
        }
        $query .= " name not LIKE '%$except%'";
      }
      if  ($toplevel)
      {
        if  (empty($name) && empty($except))
        {
          $query .= ' WHERE ';
        }
        else
        {
          $query .= ' AND ';
        }
        $query .= " substring(no, 6,  4) = '0000' ";
      }
      $query .= " ORDER BY no";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }

      // echo "$query<br>\n";
      /*****
      echo "<PRE>\n";
      print_r($rst);
      echo "</PRE>\n";
      exit;
      *****/
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->name[$data->no]  = $data->name;		
      }
      $rst->free();
      return($this->MaxItem);
    }




    //
    // SELECT By Key : substr(Orgao, 0, 5) & substr(Orgao, 9, 1)
    // (@žΩݾ)
    //
    function SelectOrgaByGroupTable($no)
    {
      $key1            = substr($no, 0, 5);
      $key2            = substr($no, 5, 4);
      $key3            = substr($no, 9, 1);
      $this->MaxItem   = 0;
      if  ($key2 != '0000')
      {
        return($this->SelectKpd2OrgaTable($no));
      }
      $this->no    = array();
      $this->name  = array();
      $query  = "SELECT * FROM Orga ";
      $query .= "WHERE ";
      $query .= "substring(no, 1,  5) = '$key1' ";
      #$query .= "AND substring(no, 6,  4) != '0000' ";
      $query .= "ORDER by no ";
      // echo "$query<br>\n";      
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      /***
      echo "$query<br>\n";
      echo "<PRE>\n";
      print_r($rst);
      echo "</PRE>\n";
      exit;
      ***/
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->no[$i]           = $data->no;
        $this->noset[$data->no] = TRUE;
        $this->name[$i]         = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2OrgaTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $no     = strtoupper(trim($this->no[$i]));
        $name   = addslashes(trim($this->name[$i]));
        $query  = "INSERT INTO orga (";
        $query .= "name, no)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$name', ";
        $query .= "'$no' ";
        $query .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2OrgaTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $no     = strtoupper(trim($this->no[$i]));
        $name   = addslashes(trim($this->name[$i]));
        $query  = "UPDATE orga SET ";
        $query .= "name = '$name' ";
        $query .= "WHERE ";
        $query .= "no = '$no' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2OrgaTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $no = strtoupper(trim($this->no[$i]));
        $query  = "DELETE FROM orga ";
        $query .= "WHERE ";
        $query .= "no = '$no' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return(true);
    }
  }
?>
