<?
  # Program id   : Kpd2SurveyDTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--qwq table survey_d
  #
  #
  class Kpd2SurveyDTable
  {
    var $MaxItem;
    var $seq;
    var $fieldno;
    var $ftitle;
    var $ftype;
    var $require;
    var $remark;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2SurveyDTable(&$db)
    {
      $this->MaxItem = 0;
      $this->seq     = array();
      $this->fieldno = array();
      $this->ftitle  = array();
      $this->ftype   = array();
      $this->require = array();
      $this->remark  = array();
      $this->_error      = '';
      $this->Db          = &$db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2SurveyDTable($seq='')
    {
      $seq            = trim($seq);
      $this->MaxItem  = 0;
      $this->seq      = array();
      $this->fieldno  = array();
      $this->ftitle   = array();
      $this->ftype    = array();
      $this->require  = array();
      $this->remark   = array();
      $query  = "SELECT * FROM survey_d WHERE seq = '$seq'";
      $query .= " ORDER BY seq, fieldno";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->seq[$i]     = $data->seq;
        $this->fieldno[$i] = $data->fieldno;
        $this->ftitle[$i]  = $data->ftitle;
        $this->ftype[$i]   = $data->ftype;
        $this->require[$i] = $data->require;
        $this->remark[$i]  = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2SurveyDTable($seq)
    {
      $seq     = (int)trim($seq);
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $ftitle  = addslashes(trim($this->ftitle[$i]));
        $ftype   = trim($this->ftype[$i]);
        $require = trim($this->require[$i]) == 't' ? 't' : 'f';
        $remark = addslashes(trim($this->remark[$i]));
        $query  = "INSERT INTO survey_d ";
        $query .= "(";
        $query .= "seq,     ";
        $query .= "fieldno, ";
        $query .= "ftitle,  ";
        $query .= "ftype,   ";
        $query .= "require, ";
        $query .= "remark   ";
        $query .= ")";
        $query .= " values ";
        $query .= "(";
        $query .= "'$seq',     ";
        $query .= "'$i',       ";
        $query .= "'$ftitle',  ";
        $query .= "'$ftype',   ";
        $query .= "'$require', ";
        $query .= "'$remark'   ";
        $query .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2SurveyDTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $seq     = (int)trim($this->seq[$i]);
        $query  = "DELETE FROM survey_d WHERE seq = '$seq'  ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return(true);
    }
  }
?>