<?
  # Program id   : Kpd2SurveyTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--q table survey
  #
  #
  class Kpd2SurveyTable
  {
    var $MaxItem;
    var $seq;
    var $organo;
    var $data;
    var $remark;
    var $modtime;
    var $modby;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2SurveyTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->seq         = array();
      $this->organo      = array();
      $this->data        = array(array());
      $this->remark      = array();
      $this->modtime     = array();
      $this->modby       = array();
      $this->_error      = '';
      $this->Db          = &$db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2SurveyTable($seq, $organo='')
    {
      $seq               = trim($seq);
      $organo            = strtoupper(trim($organo));
      $this->seq         = array();
      $this->organo      = array();
      $this->data        = array(array());
      $this->remark      = array();
      $this->modtime     = array();
      $this->modby       = array();
      $query  = "SELECT * FROM survey WHERE seq = '$seq' ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      $query .= "ORDER BY seq, organo ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        /*****
        echo("<PRE>");
        print_r($data);
        echo("</PRE>");
        *****/
        $this->seq[$i]        = $data->seq;
        $this->organo[$i]     = $data->organo;
        $this->remark[$i]     = $data->remark;
        $this->modtime[$i]    = $data->modtime;
        $this->modby[$i]      = $data->modby;
        $datas = preg_split ("/(\,)/", $data->data);
        $cnt = count($datas);
        for($j=0; $j < $cnt; $j++)
        {
          $this->data[$i][$j] = base64_decode($datas[$j]);
        }
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // SELECT  Index By organo
    //
    function SelectKpd2SurveyTableIndexByOrga($seq, $organo='')
    {
      $seq               = trim($seq);
      $organo            = strtoupper(trim($organo));
      $this->seq         = array();
      $this->organo      = array();
      $this->data        = array(array());
      $this->remark      = array();
      $this->modtime     = array();
      $this->modby       = array();
      $query  = "SELECT * FROM survey WHERE seq = '$seq' ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      $query .= "ORDER BY seq, organo ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->seq[$i]        = $data->seq;
        $ndx                  = $data->organo;
        $this->organo[$ndx]   = TRUE;
        $this->remark[$ndx]   = $data->remark;
        $this->modtime[$ndx]  = $data->modtime;
        $this->modby[$ndx]    = $data->modby;
        $datas = preg_split ("/(\,)/", $data->data);
        $cnt = count($datas);
        for($j=0; $j < $cnt; $j++)
        {
          $this->data[$ndx][$j] = base64_decode($datas[$j]);
        }
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2SurveyTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $seq    = (int)(trim($this->seq[$i]));
        $organo = strtoupper(trim($this->organo[$i]));
        $modby  = addslashes(trim($this->modby[$i]));
        $remark = addslashes(trim($this->remark[$i]));
        $data   = '{';
        $cnt1   = count($this->data[$i]);
        $cnt2   = $cnt1 - 1;
        for($j=0; $j < $cnt1; $j++)
        {
          $data .=   '"' . base64_encode(trim($this->data[$i][$j])) . '"';
          if  ($j < $cnt2)
          {
            $data .= ',';
          }
        }
        $data  .= '}';
        $query  = "INSERT INTO survey";
        $query .= "(";
        $query .= "seq,    ";
        $query .= "organo, ";
        $query .= "modby,  ";
        $query .= "remark, ";
        $query .= "data    ";
        $query .= ")";
        $query .= " values ";
        $query .= "(";
        $query .= "'$seq',    ";
        $query .= "'$organo', ";
        $query .= "'$modby',  ";
        $query .= "'$remark', ";
        $query .= "'$data'    ";
        $query .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2SurveyTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $seq    = (int)(trim($this->seq[$i]));
        $organo = strtoupper(trim($this->organo[$i]));
        $modby  = addslashes(trim($this->modby[$i]));
        $remark = addslashes(trim($this->remark[$i]));
        $data   = '{';
        $cnt1   = count($this->data[$i]);
        $cnt2   = $cnt1 - 1;
        for($j=0; $j < $cnt1; $j++)
        {
          $data .=   '"' . base64_encode(trim($this->data[$i][$j])) . '"';
          if  ($j < $cnt2)
          {
            $data .= ',';
          }
        }
        $data  .= '}';
        $query  = "UPDATE survey SET     ";
        $query .= "remark  = '$remark',  ";
        $query .= "modby   = '$modby',   ";
        $query .= "modtime = now(),      ";
        $query .= "data    = '$data'     ";
        $query .= "WHERE ";
        $query .= "seq = '$seq' AND organo = '$organo' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2SurveyTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $seq    = (int)(trim($this->seq[$i]));
        $organo = strtoupper(trim($this->organo[$i]));
        $query  = "DELETE FROM survey ";
        $query .= "WHERE seq = '$seq' ";
        if  (!empty($organo))
        {
          $query .= "AND organo = '$organo' ";
        }
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return(true);
    }
  }
?>