<?
  # Program id   : Kpd2StatusATable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--¾B table status_a
  #
  #
  class Kpd2StatusATable
  {
    var $MaxItem;
    var $yyyymm;
    var $organo;
    var $staff_cdoe;
    var $title;
    var $rank;
    var $kind;
    var $status;
    var $edate;
    var $remark;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2StatusATable(&$db)
    {
      $this->MaxItem     = 0;
      $this->yyyymm      = array();
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $this->_error      = '';
      $this->Db          = $db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2StatusATable($yyyymm, $organo='', $staff_code='')
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a WHERE yyyymm = '$yyyymm' ";
      $query .= "AND (kind NOT IN('3105','3303','3304','3403') )  ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      $query .= "ORDER BY organo,title, rank desc,kind, status,staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        # echo 'ranks=' . $ranks;

		$cnt = count($ranks);
        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }

  // ============================================================
      function SelectKpd2StatusATable_not0000($yyyymm, $organo='', $staff_code='')
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a WHERE yyyymm = '$yyyymm' ";
      $query .= "AND (kind NOT IN('3105','3303','3304','3403') )  ";
      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      $query .= "ORDER BY organo,title, rank desc,kind,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);
     #echo 'cnt=' . $cnt;
     #echo 'ranks0=' . $ranks[0];
     #echo 'ranks1=' . $ranks[1];
     #echo 'ranks2=' . $ranks[2];
     #echo 'ranks3=' . $ranks[3];	 	 	 

        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }




  // ============================================================
      function SelectKpd2StatusATable_VIEWnot0000($yyyymm, $organo='', $staff_code='')
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a WHERE yyyymm = '$yyyymm' ";

      $query .= "AND (kind NOT IN('3105','3303','3304','3403') )  ";
      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      $query .= "ORDER BY organo,staff_code,title, rank desc,kind,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);
        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }



  // ============================================================
      function SelectKpd2StatusATable_ur2_pdf($yyyymm, $organo='', $kind_spec='')
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a WHERE yyyymm = '$yyyymm' ";
      
      switch ($kind_spec) {
        case "1":
          $query .= "AND (kind IN('3105') )  ";
          break;
        case "2":
          $query .= "AND (kind IN('3303','3304') )  ";
          break;
        case "3":
          $query .= "AND (kind IN('3403') )  ";
          break;
        default:
          break;
      }
      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      $query .= "ORDER BY organo,staff_code,title, rank desc,kind,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);
     #echo 'cnt=' . $cnt;
     #echo 'ranks0=' . $ranks[0];
     #echo 'ranks1=' . $ranks[1];
     #echo 'ranks2=' . $ranks[2];
     #echo 'ranks3=' . $ranks[3];	 	 	 

        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }






    // ---------------------------------------------------------
	//  select all  for manager
	// ---------------------------------------------------------
    function SelectKpd2StatusATable_all($yyyymm, $organo='', $staff_code='')
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a WHERE yyyymm = '$yyyymm' ";
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }

      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      $query .= "ORDER BY organo,title, rank desc,kind,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);
        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }


    //
    // SELECT  for manager print all  (kpd2.statusa.r1_pdf.php)
    //
    function SelectKpd2StatusATable_prn_all($yyyymm, $organo='', $staff_code='', $title='', $kind='', $rank0='', $rank1='', $rank2='', $rank3='' )
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a A , orga B WHERE (A.organo = B.no) AND (yyyymm = '$yyyymm') ";
      $query .= "AND (kind NOT IN('3105','3303','3304','3403') )  ";
      $query .= "AND (A.organo NOT LIKE '3833%' )";   
      $query .= "AND (A.organo NOT LIKE '3834%' )";   
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      if  (!empty($title))
      {
        $query .= "AND title = '$title' ";
      }
      if  (!empty($kind))
      {
        $query .= "AND kind = '$kind' ";
      }
      if  (!empty($rank0) )
      {
        $query .= "AND rank[1] = '$rank0' ";     //$rank PHP arrayбq0}l     SQL arrayбq}l
      }

      $query .= "ORDER BY pri,organo,title, rank desc,kind,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();

        $ErrMsg = '_error=' . $this->_error ;
        JScriptWindowAlert($ErrMsg, $cmdClose);

        return(0);
      }
      $this->MaxItem=$rst->numRows();

      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);
        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
  // ===================================================
  //  ĤGq query  for H
  // ===================================================
      $query  = "SELECT * FROM status_a A , orga B WHERE (A.organo = B.no) AND (yyyymm = '$yyyymm') ";
      $query .= "AND (kind IN('3105','3303','3304','3403') )  ";
      $query .= "AND (A.organo NOT LIKE '3833%' )";                    
      $query .= "AND (A.organo NOT LIKE '3834%' )";                   
      if  (!empty($organo))
      {
        $query .= "AND organo = '$organo' ";
      }
      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      if  (!empty($title))
      {
        $query .= "AND title = '$title' ";
      }
      if  (!empty($kind))
      {
        $query .= "AND kind = '$kind' ";
      }
      if  (!empty($rank0))
      {
        $query .= "AND rank[1] = '$rank0' ";     //$rank PHP arrayбq0}l     SQL arrayбq}l
      }

      $query .= "ORDER BY kind, pri, organo,title, rank desc,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }

      $MaxItem_last   = $this->MaxItem;        // NW@ӬdߪMaxItem OU
      $this->MaxItem += $rst->numRows();       // Ʊbarray ᭱
  
      for($i=$MaxItem_last;$i < $this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);

        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
 
      $rst->free();
    

  // ===================================================
  //  ĤTq query  for 
  // ===================================================
      $query  = "SELECT * FROM status_a A , orga B WHERE (A.organo = B.no) AND (yyyymm = '$yyyymm') ";
      $query .= "AND ( (A.organo LIKE '3833%') OR (A.organo LIKE '3834%')) ";  
      $query .= "AND (staff_code NOT IN('0000') )  ";
      if  (!empty($staff_code))
      {
        $query .= "AND staff_code = '$staff_code' ";
      }
      if  (!empty($title))
      {
        $query .= "AND title = '$title' ";
      }
      if  (!empty($kind))
      {
        $query .= "AND kind = '$kind' ";
      }
      if  (!empty($rank0))
      {
        $query .= "AND rank[1] = '$rank0' ";
      }

      $query .= "ORDER BY pri, organo, title,rank desc,kind,status, staff_code ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }

      $MaxItem_last   = $this->MaxItem;       // NW@ӬdߪMaxItem OU
      $this->MaxItem += $rst->numRows();      // Ʊbarray ᭱
  
      for($i=$MaxItem_last;$i < $this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);

        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
 
      $rst->free();
      return($this->MaxItem);
    }



    //
    // SELECT  for spec
    //
    function SelectKpd2StatusATable_spec($yyyymm, $kind_one, $kind_two)
    {
      $yyyymm            = (int)(trim($yyyymm));
      $organo            = strtoupper(trim($organo));
      $staff_code        = strtoupper(trim($staff_code));
      $this->MaxItem     = 0;
      $this->organo      = array();
      $this->staff_code  = array();
      $this->title       = array();
      $this->rank        = array(array());
      $this->kind        = array();
      $this->status      = array();
      $this->edate       = array();
      $this->remark      = array();
      $query  = "SELECT * FROM status_a WHERE yyyymm = '$yyyymm' ";
      if  (!empty($kind_one))
      {
        $query .= "AND (kind = '$kind_one' ";
      }
      if  (!empty($kind_two))
      {
        $query .= "OR kind = '$kind_two') ";
      }
	  else
	  {
    	$query .= ")";
	  }
	  
      $query .= "ORDER BY organo, rank desc, staff_code, title ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->yyyymm[$i]     = $data->yyyymm;
        $this->organo[$i]     = $data->organo;
        $this->staff_code[$i] = $data->staff_code;
        $this->title[$i]      = $data->title;
        $tmp1  = preg_replace("/^{(\S+)}$/","$1", $data->rank);
        $ranks = preg_split ("/[\s,]+/", $tmp1);
        $ranks = preg_replace("/\"/","", $ranks);
        $cnt = count($ranks);
        for($j=0; $j < $cnt; $j++)
        {
          $this->rank[$i][$j] = $ranks[$j];
        }
        $this->kind[$i]       = $data->kind;
        $this->status[$i]     = $data->status;
        $this->edate[$i]      = $data->edate;
        $this->remark[$i]     = $data->remark;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2StatusATable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $yyyymm     = (int)(trim($this->yyyymm[$i]));
        $organo     = strtoupper(trim($this->organo[$i]));
        $staff_code = strtoupper(trim($this->staff_code[$i]));
        $title      = strtoupper(trim($this->title[$i]));
        $kind       = strtoupper(trim($this->kind[$i]));
        $status     = strtoupper(trim($this->status[$i]));
        $rank       = '{';
        $cnt1       = count($this->rank[$i]);
        $cnt2       = $cnt1 - 1;
		$edate      = strtoupper(trim($this->edate[$i]));		
        for($j=0; $j < $cnt1; $j++)
        {
          $rank .=   '"' . strtoupper(trim($this->rank[$i][$j])) . '"';
          if  ($j < $cnt2)
          {
            $rank .= ',';
          }
        }
        
		if ($staff_code == '0000')  // for LB
		{ 
		  $rank  .= '"","","",""';
		}
		$rank  .= '}';
        $query  = "INSERT INTO status_a ";
        $query .= "(";
        $query .= "yyyymm, ";
        $query .= "organo, ";
        $query .= "staff_code, ";
        $query .= "title,  ";
        $query .= "rank,   ";
        $query .= "kind,   ";
        $query .= "status,  ";
        $query .= "edate";
		$query .= ")";
        $query .= " values ";
        $query .= "(";
        $query .= "'$yyyymm', ";
        $query .= "'$organo', ";
        $query .= "'$staff_code', ";
        $query .= "'$title',  ";
        $query .= "'$rank',   ";
        $query .= "'$kind',   ";
        $query .= "'$status',  ";
        $query .= "'$edate'";
        $query .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2StatusATable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
		$yyyymm     = (int)(trim($this->yyyymm[$i]));
        $organo     = strtoupper(trim($this->organo[$i]));
        $staff_code = strtoupper(trim($this->staff_code[$i]));
        $query  = "DELETE FROM status_a ";
        $query .= "WHERE yyyymm = '$yyyymm' AND organo = '$organo' ";
		if  (!empty($staff_code))
        {
          $query .= "AND staff_code = '$staff_code' ";
        }
         # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return(true);
    }
  }
?>
