<?
  # Program id   : Kpd2SurveyTTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--qD table SurveyT
  #
  #
  class Kpd2SurveyTTable
  {
    var $MaxItem;
    var $seq;
    var $title;
    var $creator;
    var $bdate;
    var $edate;
    var $modtime;
    var $modby;
    var $remark;
    var $sample;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2SurveyTTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->seq         = array();
      $this->title       = array();
      $this->creator     = array();
      $this->bdate       = array();
      $this->edate       = array();
      $this->modtime     = array();
      $this->modby       = array();
      $this->remark      = array();
      $this->sample      = array();	  
      $this->_error      = '';
      $this->Db          = &$db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2SurveyTTable($seq='', $chkdate=FALSE)
    {
      $seq               = trim($seq);
      $this->MaxItem     = 0;
      $this->seq         = array();
      $this->title       = array();
      $this->creator     = array();
      $this->bdate       = array();
      $this->edate       = array();
      $this->modtime     = array();
      $this->modby       = array();
      $this->remark      = array();
      $this->sample      = array();	  
      $query  = "SELECT * FROM survey_t ";
      $tmp    = '';
      if  (strlen($seq))
      {
        $tmp .= "WHERE seq = '$seq' ";
      }
      if  ($chkdate == TRUE)
      {
        if  (empty($tmp))
        {
          $tmp .= "WHERE ";
        }
        else
        {
          $tmp .= "AND ";
        }
        $tmp .= "bdate <= now() AND edate >= now() ";
      }
      $tmp   .= " ORDER BY seq desc";
      $query .= $tmp; 
      // echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->seq[$i]     = $data->seq;
        $this->title[$i]   = $data->title;
        $this->creator[$i] = $data->creator;
        $this->bdate[$i]   = $data->bdate;
        $this->edate[$i]   = $data->edate;
        $this->modtime[$i] = $data->modtime;
        $this->modby[$i]   = $data->modby;
        $this->remark[$i]  = $data->remark;
        $this->sample[$i]  = $data->sample;		
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // Get Survey form ID
    //
    function SelectSurveyFormID()
    {
      $query  = "SELECT currval('survey_t_seq_seq') ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->seq[$i]     = $data->currval;
      }
      $rst->free();
      return($this->seq[0]);
    }
    //
    // INSERT
    //
    function InsertKpd2SurveyTTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $title   = addslashes(trim($this->title[$i]));
        $creator = addslashes(trim($this->creator[$i]));
        $bdate   = trim($this->bdate[$i]);
        $edate   = trim($this->edate[$i]);
        $modby   = addslashes(trim($this->modby[$i]));
        $remark  = addslashes(trim($this->remark[$i]));
        $sample  = trim($this->sample[$i]);		
        $query   = "INSERT INTO survey_t ";
        $query  .= "(";
        $query  .= "title,   ";
        $query  .= "creator, ";
        $query  .= "bdate,   ";
        $query  .= "edate,   ";
        $query  .= "modby,   ";
        $query  .= "remark,  ";
        $query  .= "sample   ";		
        $query  .= ")";
        $query  .= " values ";
        $query  .= "(";
        $query  .= "'$title',   ";
        $query  .= "'$creator', ";
        $query  .= "'$bdate',   ";
        $query  .= "'$edate',   ";
        $query  .= "'$modby',   ";
        $query  .= "'$remark',  ";
        $query  .= "'$sample'   ";
        $query  .= ")";
        // echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2SurveyTTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $seq     = (int)trim($this->seq[$i]);
        $title   = addslashes(trim($this->title[$i]));
        $creator = addslashes(trim($this->creator[$i]));
        $bdate   = trim($this->bdate[$i]);
        $edate   = trim($this->edate[$i]);
        $modby   = addslashes(trim($this->modby[$i]));
        $remark  = addslashes(trim($this->remark[$i]));
        $sample  = trim($this->sample[$i]);		
        $query   = "UPDATE survey_t SET   ";
        $query  .= "title   = '$title',   ";
        $query  .= "creator = '$creator', ";
        $query  .= "bdate   = '$bdate',   ";
        $query  .= "edate   = '$edate',   ";
        $query  .= "modtime = now(),      ";
        $query  .= "modby   = '$modby',   ";
        $query  .= "remark  = '$remark',  ";
        $query  .= "sample  = '$sample'   ";		
        $query  .= "WHERE ";
        $query  .= "seq = '$seq' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2SurveyTTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $seq     = (int)trim($this->seq[$i]);
        $query  = "DELETE FROM survey_t ";
        $query .= "WHERE ";
        $query .= "seq = '$seq' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          // $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          // $this->Db->rollback();
          return($cmdTuples);
        }
      }
      // $this->Db->commit();
      return(true);
    }
  }
?>
