<?
  # Program id   : Kpd2UsersTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--ϥΪ̥NX table
  #
  #
  class Kpd2UsersTable
  {
    var $MaxItem;
    var $email;
    var $organo;
    var $active;
    var $activeid;
    var $regdate;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2UsersTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->email       = array();
      $this->organo      = array();
      $this->active      = array();
      $this->activeid    = array();
      $this->regdate     = array();
      $this->_error      = '';
      $this->Db          = &$db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2UsersTable($email='', $organo='')
    {
      $email = AddSlashes(trim($email));
      $organo = strtoupper(trim($organo));
      $query  = "SELECT * FROM users ";
      if  (!empty($email))
      {
        $query .= "WHERE email = '$email' ";
      }
      if  (!empty($organo))
      {
        if  (empty($email))
        {
          $query .= "WHERE ";
        }
        else
        {
          $query .= "AND ";
        }
        $query .= "organo = '$organo' ";
      }
      $query .= "ORDER BY organo, email ";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->email[$i]     = $data->email;
        $this->organo[$i]    = $data->organo;
        $this->active[$i]    = $data->active;
        $this->activeid[$i]  = $data->activeid;
        $this->regdate[$i]   = $data->regdate;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2UsersTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email        = addslashes(trim($this->email[$i]));
        $organo       = strtoupper(trim($this->organo[$i]));
        $activeid     = $this->activeid[$i];
        $query  = "INSERT INTO users (";
        $query .= "email, organo, activeid)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$email',  ";
        $query .= "'$organo', ";
        $query .= "'$activeid'";
        $query .= ")";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2UsersTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email    = addslashes(trim($this->email[$i]));
        $organo   = strtoupper(trim($this->organo[$i]));
        $active   = $this->active[$i];
        $activeid = $this->activeid[$i];
        $query    = "UPDATE users SET ";
        $query   .= "active   = '$active'";
	if  (!empty($activeid))
	{
          $query .= ", activeid = '$activeid'";
	}
        $query   .= "WHERE ";
        $query   .= "email  = '$email' AND ";
        $query   .= "organo = '$organo' ";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        # echo "$query<br>\n" . $cmdTuples;
        # exit;
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE -- Active account
    //
    function ActiveKpd2UsersTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email   = addslashes(trim($this->email[$i]));
        $active   = $this->active[$i];
        $activeid = addslashes(trim($this->activeid[$i]));
        $query    = "UPDATE users SET ";
        $query   .= "active = '$active'  ";
        $query   .= "WHERE ";
        $query   .= "email = '$email' ";
        $query   .= "AND ";
        $query   .= "activeid = '$activeid' ";
        $rst      = $this->Db->Query($query);
        # echo "$query<br>\n" . $cmdTuples;
        # exit;
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2UsersTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $email  = addslashes(trim($this->email[$i]));
        $organo = strtoupper(trim($this->organo[$i]));
        $query  = "DELETE FROM users ";
        $query .= "WHERE ";
        $query .= "email  = '$email' AND ";
        $query .= "organo = '$organo' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return(true);
    }
  }
?>
