<?
  #
  # Program id     : kpd2.statusa.r1_pdf.php
  #
  # subject        : F¾¾uBdκqt--CL¾Bd
  #                       
  include('../include/Authen.inc.php');
  #
  require_once("../include/PDFGenerator.inc.php");
  #
  $PDFReport =& new PDFGenerator('../xml/kpd2.statusa.r1_pdf.xml', FALSE, '/kpd2/manager/temp');
  if  (!empty($PDFReport->ErrMsg))
  {
    echo $PDFReport->ErrMsg;
    exit;
  }
  include("../include/kpd2.commonvar.inc.php");
  #
  include('../include/dbconnect.inc.php');
  #
  require_once('../include/Kpd2OrgaTable.inc.php');
  #
  require_once('../include/Kpd2CodeTable.inc.php');
  #
  require_once('../include/Kpd2StatusATable.inc.php');
  #
  require_once('../include/Kpd2LogsTable.inc.php');
  #
  require_once('../include/Str2Float.inc.php');
  #
  # Ʈws
  #
  $db_kpd2     =& dbconnect();
  #
  $cmdClose='window.close()';
  #
  $yy     = (int)$_POST['yy'];
  $mm     = (int)$_POST['mm'];
  $organo = trim($_POST['organo']);
  $title  = trim($_POST['title']);
  $kind   = trim($_POST['kind']);
  $rank0  = trim($_POST['rank0']);
  $rank1  = trim($_POST['rank1']);
  $rank2  = trim($_POST['rank2']);  
  $rank3  = trim($_POST['rank3']);
  $staff_code  = trim($_POST['staff_code']);  
    
  if  ($organo == 'ALL')
  {
    $organo = '';
  }
  #
  $yyyymm = sprintf("%04d%02d",$yy+1911,$mm);
  $Kpd2StatusAQTable =& new Kpd2StatusATable($db_kpd2);
  
  
  if  ($organo == '')
  {
     if  ($Kpd2StatusAQTable->SelectKpd2StatusATable_prn_all($yyyymm, $organo, $staff_code, $title, $kind, $rank0, $rank1, $rank2, $rank3)==0)
     {
       $ErrMsg = $yyyymm . '' . $organo . '->dL!!!';
       JScriptWindowAlert($ErrMsg, $cmdClose);
       exit;
     }
  }
  else
  {
     if  ($Kpd2StatusAQTable->SelectKpd2StatusATable_all($yyyymm, $organo, $staff_code, $title, $kind, $rank0, $rank1, $rank2, $rank3)==0)
     {
       $ErrMsg = $yyyymm . '' . $organo . '->dL!!!';
       JScriptWindowAlert($ErrMsg, $cmdClose);
       exit;
     }
  }
  
  
  /*****
  echo("<PRE>\n");
  print_r($Kpd2StatusAQTable); 
  echo("</PRE>\n");
  *****/
  #
  # 'EPK' => '¾t',
  # 'EPT' => '¾',
  # 'MCL' => '¾ʪA',
  # 'RNK' => '¾'
  #
  $Kpd2Code_EPK   =& new Kpd2CodeTable($db_kpd2);
  $Kpd2Code_EPK->SelectKpd2CodeTableIndexByCode('EPK');
  $Kpd2Code_EPT   =& new Kpd2CodeTable($db_kpd2);
  $Kpd2Code_EPT->SelectKpd2CodeTableIndexByCode('EPT');
  $Kpd2Code_MCL   =& new Kpd2CodeTable($db_kpd2);
  $Kpd2Code_MCL->SelectKpd2CodeTableIndexByCode('MCL');
  $Kpd2Code_RNK   =& new Kpd2CodeTable($db_kpd2);
  $Kpd2Code_RNK->SelectKpd2CodeTableIndexByCode('RNK');
  #
  $data          =& new stdClass;
  $data->MaxItem = 0;
  $data->organo  = array();
  $data->title   = array();
  $data->rank    = array();
  $data->kind    = array();
  $data->sum     = array();
  $data->status  = array();
  $first = TRUE;
  $organo = '';
  $title  = '';
  $rank   = '';
  $kind   = '';
  $sum    = 0;
  $status = '';
  $j      = 0;
  for($i=0;$i<$Kpd2StatusAQTable->MaxItem;$i++)
  {
    $rank_c = DisplayRank($Kpd2Code_RNK, $Kpd2StatusAQTable->rank[$i][0],
                                         $Kpd2StatusAQTable->rank[$i][1],
                                         $Kpd2StatusAQTable->rank[$i][2],
                                         $Kpd2StatusAQTable->rank[$i][3]
                         ); 
    if  ($first                                    || 
         $organo != $Kpd2StatusAQTable->organo[$i] ||   
         $title  != $Kpd2StatusAQTable->title[$i]  ||   
         $rank   != $rank_c                        ||   
         $kind   != $Kpd2StatusAQTable->kind[$i]   ||
         $status != $Kpd2StatusAQTable->status[$i]		 
        )
    {
      if  ($first)
      {
        $first = FALSE;
      }
      else
      {
        $data->organo[$j]  = $organo;
        $data->title[$j]   = $title;
        $data->rank[$j]    = $rank;
        $data->kind[$j]    = $kind;
        $data->sum[$j]     = $sum;
        $data->status[$j]  = $status;
        $j++;
        $sum               = 0;
      }
      $organo = $Kpd2StatusAQTable->organo[$i];
      $title  = $Kpd2StatusAQTable->title[$i];
      $rank   = $rank_c;
      $kind   = $Kpd2StatusAQTable->kind[$i];
      $status = $Kpd2StatusAQTable->status[$i];
    }    	        
    $sum++;
    if (!empty($Kpd2StatusAQTable->status[$i]))
    {
      $status = $Kpd2StatusAQTable->status[$i];
    }
  }  
  if  (!$first)
  {
    $data->organo[$j]  = $organo;
    $data->title[$j]   = $title;
    $data->rank[$j]    = $rank;
    $data->kind[$j]    = $kind;
    $data->sum[$j]     = $sum;
    $data->status[$j]  = $status;
    $j++;
  }
  $data->MaxItem = $j;
  #
  $RecCnt   = 0;
  $PageSize = 16;
  $TotPages = ceil($Kpd2StatusAQTable->MaxItem / $PageSize);
  $page     = 0;
  $RowSize  = 40;
  //
  $f1_1_x   = 52;
  $f1_1_y   = 645;
  $f1_1_s   = 10;
  $f1_2_x   = 52;
  $f1_2_y   = 665;
  $f1_2_s   = 10;
  //
  $f2_1_x   = 182;
  $f2_1_y   = 645;
  $f2_1_s   = 10;
  $f2_2_x   = 182;
  $f2_2_y   = 665;
  $f2_2_s   = 10;
  //
  $f3_1_x   = 252;
  $f3_1_y   = 669;
  $f3_1_s   = 8;
  //
  $f4_1_x   = 322;
  $f4_1_y   = 645;
  $f4_1_s   = 10;
  $f4_2_x   = 322;
  $f4_2_y   = 665;
  $f4_2_s   = 10;
  //
  $f5_1_x   = 405;
  $f5_1_y   = 665;
  $f5_1_s   = 10;
  //
  $f6_1_x   = 432;
  $f6_1_y   = 669;
  $f6_1_s   = 10;
  //
  for($i=0;$i<$data->MaxItem;$i++)
  {
    $RecCnt++;
    if  ($page == 0 || $RecCnt > $PageSize)
    {
      if  ($page > 0)
      {
        $PDFReport->EndPage();
      }
      $page++;
      $RecCnt = 1;
      $PDFReport->NewPage($page);
      $ds = sprintf("إ%4d ~%3d %3d ", date("Y")-1911, date("m"), date("d"));
      $PDFReport->ShowText($ds, 210, 780, 16);
      $ps = sprintf("%4d/%4d", $page, $TotPages);
      $PDFReport->ShowText($ps, 530, 780, 10, 'efont');
    }
    $rowinc     = (-1) * $RowSize * ( $RecCnt - 1);
    $kind       = $data->kind[$i];
    $kind_c     = $Kpd2Code_EPK->name[$kind];
    $title      = $data->title[$i];
    $title_c    = $Kpd2Code_EPT->name[$title];
    $organo     = $data->organo[$i];
    $organame   = '';
    unset($Kpd2OrgaTable);
    $Kpd2OrgaTable   =& new Kpd2OrgaTable($db_kpd2);
    $Kpd2OrgaTable->SelectKpd2OrgaTable($organo);
    $organame = $Kpd2OrgaTable->name[0];
	
    if (strlen($organame) > 10 )
	{
    	if (substr($organame,0,10) == 'F')   //ǳrӪ,줣
    	{
    	   $organame = str_replace("F", "", $organame);   
    	}
	}
    if  (strlen($organame) > 24)
    {
      $f1_2_s = 8;
    }
    else
    {
      $f1_2_s = 10;
    }
    

    if  (strlen($kind_c) > 8)
    {
      $f4_2_s = 8;
    }
    else
    {
      $f4_2_s = 10;
    }
    
    
    
    $rank_c = $data->rank[$i];
    $sum    = str_pad(Float2CommaStr($data->sum[$i], 0), 5, " ", STR_PAD_LEFT);
    $status_c  = $Kpd2Code_MCL->name[$data->status[$i]];
    $PDFReport->ShowText($organo,     $f1_1_x, $f1_1_y + $rowinc, $f1_1_s, 'efont');
    $PDFReport->ShowText($organame,   $f1_2_x, $f1_2_y + $rowinc, $f1_2_s);
    $PDFReport->ShowText($title,      $f2_1_x, $f2_1_y + $rowinc, $f2_1_s, 'efont');
    $PDFReport->ShowText($title_c,    $f2_2_x, $f2_2_y + $rowinc, $f2_2_s);
    $PDFReport->ShowTextBlocked($rank_c, $f3_1_x, $f3_1_y + $rowinc, $f3_1_s, 14);
    $PDFReport->ShowText($kind,       $f4_1_x, $f4_1_y + $rowinc, $f4_1_s, 'efont');
    $PDFReport->ShowText($kind_c,     $f4_2_x, $f4_2_y + $rowinc, $f4_2_s);
    $PDFReport->ShowText($sum,        $f5_1_x, $f5_1_y + $rowinc, $f5_1_s, 'efont');
    $PDFReport->ShowTextBlocked($status_c, $f6_1_x, $f6_1_y + $rowinc, $f6_1_s, 30);
  }
  /*****
  $PDFReport->ShowText('DG',   20,  25, 14);
  $PDFReport->ShowText('ƥDG', 150, 25, 14);
  $PDFReport->ShowText('ժG',   300, 25, 14);
  $PDFReport->ShowText('ӿHG', 420, 25, 14);
  *****/
  $foot  = 'CL : ' . sprintf("%4d", $Kpd2StatusAQTable->MaxItem) . '    ' ;
  $foot .= 'CLG' . (date("Y")-1911) . ' ~ ' . date("m") . '  ' . date("d") . '  ';
  $foot .= date("H:i:s");
  $PDFReport->ShowText($foot, 380, 15, 8);
  $PDFReport->EndPage();
  $PDFReport->close();
  $PDFReport->delete();
  $PDFReport->OutputDoc();
  #$PDFReport->quit();
?>
